(* Here we've just made an interface for all the functions one needs to write
 * to define an abstract machine for our arithmetic language.
 *)
signature ARITHMETIC_MACHINE =
sig
  datatype exp = Constant of int
                | Negate of exp
                | Add of exp * exp
                | Subtract of exp * exp
                | Multiply of exp * exp

  type oper
  type code = oper list
  val compile : exp -> code

  type state = int list
  exception BadInput;
  val step : oper -> state -> state

  type value = int
  val extract : state -> value
end
